/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TGENEPRODUCTDESC")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tgeneproductdesc.findAll", query = "SELECT t FROM Tgeneproductdesc t"),
    @NamedQuery(name = "Tgeneproductdesc.findByModulecode", query = "SELECT t FROM Tgeneproductdesc t WHERE t.tgeneproductdescPK.modulecode = :modulecode"),
    @NamedQuery(name = "Tgeneproductdesc.findByProductcode", query = "SELECT t FROM Tgeneproductdesc t WHERE t.tgeneproductdescPK.productcode = :productcode"),
    @NamedQuery(name = "Tgeneproductdesc.findByLanguagecode", query = "SELECT t FROM Tgeneproductdesc t WHERE t.tgeneproductdescPK.languagecode = :languagecode"),
    @NamedQuery(name = "Tgeneproductdesc.findByRecordversion", query = "SELECT t FROM Tgeneproductdesc t WHERE t.recordversion = :recordversion"),
    @NamedQuery(name = "Tgeneproductdesc.findByDescription", query = "SELECT t FROM Tgeneproductdesc t WHERE t.description = :description")})
public class Tgeneproductdesc implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TgeneproductdescPK tgeneproductdescPK;
    @Column(name = "RECORDVERSION")
    private BigInteger recordversion;
    @Column(name = "DESCRIPTION")
    private String description;
    @JoinColumn(name = "LANGUAGECODE", referencedColumnName = "LANGUAGECODE", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tgenelanguage tgenelanguage;
    @JoinColumns({
        @JoinColumn(name = "MODULECODE", referencedColumnName = "MODULECODE", insertable = false, updatable = false),
        @JoinColumn(name = "PRODUCTCODE", referencedColumnName = "PRODUCTCODE", insertable = false, updatable = false)})
    @ManyToOne(optional = false)
    private Tgeneproduct tgeneproduct;

    public Tgeneproductdesc() {
    }

    public Tgeneproductdesc(TgeneproductdescPK tgeneproductdescPK) {
        this.tgeneproductdescPK = tgeneproductdescPK;
    }

    public Tgeneproductdesc(String modulecode, String productcode, String languagecode) {
        this.tgeneproductdescPK = new TgeneproductdescPK(modulecode, productcode, languagecode);
    }

    public TgeneproductdescPK getTgeneproductdescPK() {
        return tgeneproductdescPK;
    }

    public void setTgeneproductdescPK(TgeneproductdescPK tgeneproductdescPK) {
        this.tgeneproductdescPK = tgeneproductdescPK;
    }

    public BigInteger getRecordversion() {
        return recordversion;
    }

    public void setRecordversion(BigInteger recordversion) {
        this.recordversion = recordversion;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Tgenelanguage getTgenelanguage() {
        return tgenelanguage;
    }

    public void setTgenelanguage(Tgenelanguage tgenelanguage) {
        this.tgenelanguage = tgenelanguage;
    }

    public Tgeneproduct getTgeneproduct() {
        return tgeneproduct;
    }

    public void setTgeneproduct(Tgeneproduct tgeneproduct) {
        this.tgeneproduct = tgeneproduct;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tgeneproductdescPK != null ? tgeneproductdescPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tgeneproductdesc)) {
            return false;
        }
        Tgeneproductdesc other = (Tgeneproductdesc) object;
        if ((this.tgeneproductdescPK == null && other.tgeneproductdescPK != null) || (this.tgeneproductdescPK != null && !this.tgeneproductdescPK.equals(other.tgeneproductdescPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tgeneproductdesc[ tgeneproductdescPK=" + tgeneproductdescPK + " ]";
    }
    
}
